function y=sf_sticky_hard_spheres(varargin)
% SF_STICKY_HARD_SPHERES Sticky Hard Sphere structure factor [Baxter/Menon] S(q)
%   M = SF_STICKY_HARD_SPHERES builds a Sticky Hard Sphere structure factor S(q)
%          (for e.g. spheres in dielectric liquids)
%     The 'x' wave-vector/momentum axis is usually in nm-1 or Angs-1.
%     The parameter 'R' is given in inverse unit of the axis (that is nm or Angs)
%       and corresponds with the typical distance between scattering objects.
%     The parameter 'rho' is a reduced density. A value of rho close to 1 is for 
%       a cristalline material. A value of 0 corresponds with a perfect liquid/gas S(q)=1.
%     Typical values for parameters are R=50 Angs, rho=0.04, tau=0.15
%     The Sticky Hard Sphere model converges to the Hard Sphere model [PY] with
%       increasing tau (e.g. tau > 10).
%     The model returns the S(q) structure factor.
%
%   Model parameters:
%     p(1)=R    hard sphere radius [1/x]', ...
%     p(2)=rho  hard sphere volume fraction', ...
%     p(3)=tau  stickiness
%   The model M is returned, and can be evaluated with e.g. y=M(p, x)
%
%   M = SF_STICKY_HARD_SPHERES([ parameters ]) creates a model with specified model parameters.
%
%   Y = SF_STICKY_HARD_SPHERES(p, X) creates the model and returns its value on axis X.
%
% Ref: S.V.G. Menon, C. Manobar, and K. Srinivasa Rao. J. Chem. Phys., 95 (1991) 9186
%   Extracted from sasfit/sasfit_sq/sasfit_sq_StickyHardSphere.c
%   I. Bressler, et al, Journal of Applied Crystallography, 2015, 48 (5), 1587-1598
% Example: m=sf_sticky_hard_spheres([10 0.2 0.15]); isvector(m('', 0:0.01:1));
% Example: m=sf_sticky_hard_spheres([10 0.2 0.15]); h=plot(m,'',0:0.01:1); ...
%   tf=ishandle(h); close(gcf); tf
% See also iData, iFunc, sf_hard_spheres, sf_square_well

y.Name      = [ 'Sticky Hard Sphere S(q) (1D) [' mfilename ']' ];
y.Description='Sticky Hard Sphere scattering structure factor [Baxter/Menon]';
y.Parameters={'R hard sphere radius [1/x]', ...
              'rho hard sphere volume fraction', ...
              'tau stickiness'};
y.Dimension =1;
y.Expression= { ...
  'RHS=abs(p(1)); fp=max(0, min(p(2), 1)); tau=abs(p(3));q=abs(x);' ...
  'if (p(2) == 0.0) signal=ones(size(x)); else ' ...
  'kappa = 2*q*RHS; ' ...
	'epsi = tau+(fp/(1.0-fp)); ' ...
	'gama = fp*(1+fp/2.0)/(3.0*power(1.0-fp,2.0)); ' ...
	'lamb = 6.0/fp*(epsi-sqrt(epsi*epsi-gama)); ' ...
	'mu = lamb*fp*(1-fp); ' ...
	'beta = -(3*fp*power(2+fp,2.0)-2.*mu*(1+7*fp+fp*fp)+mu*mu*(2+fp)) / (2.*power(1.-fp,4)); ' ...
	'alpha = power(1+2.*fp-mu,2)/power(1-fp,4); ' ...
	'CQ =    alpha*power(kappa,3).*(sin(kappa)-kappa.*cos(kappa)); ' ...
	'CQ = CQ+beta*power(kappa,2.).*(2.*kappa.*sin(kappa)-(power(kappa,2.)-2.).*cos(kappa)-2.); ' ...
	'CQ = CQ+0.5*fp*alpha*((4*power(kappa,3)-24*kappa).*sin(kappa)-(power(kappa,4)-12*power(kappa,2.)+24).*cos(kappa)+24); ' ...
	'CQ = -24.*fp*power(kappa,-6).*CQ; ' ...
	'CQ = CQ-2*power(fp*lamb,2.)*(1.-cos(kappa)).*power(kappa,-2.) + 2.*fp*lamb./kappa.*sin(kappa); ' ...
	'signal = 1 ./ (1-CQ); end'
};
% use ifthenelse anonymous function
% <https://blogs.mathworks.com/loren/2013/01/10/introduction-to-functional-programming-with-anonymous-functions-part-1/>
% iif( cond1, exec1, cond2, exec2, ...)
iif = @(varargin) varargin{2 * find([varargin{1:2:end}], 1, 'first')}();
y.Guess     = @(x,signal) iif(...
  ~isempty(signal)&&numel(signal)==numel(x), @() [ pi/sum(signal(:).*x(:))*sum(signal(:)) max(signal(:)-1) 0.15 ], ...
  true,             @() [10 0.2 0.15]);
y = iFunc(y);

if nargin == 1 && isnumeric(varargin{1})
  y.ParameterValues = varargin{1};
elseif nargin > 1
  y = y(varargin{:});
end

